unit Calc1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ParseExpr, Menus;
const
  Nundo = 41;
type
  TForm1 = class(TForm)
    ResultEdit: TEdit;
    Evaluate: TButton;
    XEdit: TEdit;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    PointButton: TButton;
    ExpressionEdit: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Button29: TButton;
    Button31: TButton;
    Button35: TButton;
    Button38: TButton;
    Button39: TButton;
    Button40: TButton;
    Button12: TButton;
    Button13: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button30: TButton;
    Button33: TButton;
    Button34: TButton;
    Label3: TLabel;
    FunctionsCombo: TComboBox;
    Button32: TButton;
    Label1: TLabel;
    yEdit: TEdit;
    ZEdit: TEdit;
    Button1: TButton;
    Button36: TButton;
    Button37: TButton;
    Label4: TLabel;
    Button42: TButton;
    Helplabel: TLabel;
    PopupMenu1: TPopupMenu;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    Label5: TLabel;
    NEvalLabel: TLabel;
    OptimizeCheck: TCheckBox;
    HexCheck: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure EvaluateClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure XEditChange(Sender: TObject);
    procedure YEditChange(Sender: TObject);
    procedure ZEditChange(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure Button24KeyPress(Sender: TObject; var Key: Char);
    procedure Button32Click(Sender: TObject);
    procedure FunctionsComboChange(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure ExpressionEditChange(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure OptimizeCheckClick(Sender: TObject);
  private
    { Private declarations }
    X, Y, Z: Double;
    PrevText: array[0..Nundo - 1] of string;
    Iprevtext: Integer;
    istartundo: Integer;
    MyParser: TExpressionParser;
    procedure AddToEdit(S: string);
    procedure UpdateUndo;
    procedure SetUndoText;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Math;
{$R *.DFM}
const
  Maxstrings = 27;
  Helpstrings: array[0..Maxstrings - 1] of string = (
    '() = brackets',
    'abs(x) = absolute value',
    'arccos(x) = inverse cosine of x in rad',
    'arccosh(x) = inverse hyperbolic cosine in rad',
    'arcsin(x) = inverse sine of x in rad',
    'arcsinh(x) = inverse hyperbolic sine in rad',
    'cos(x) = cosine of an angle in rad',
    'cosh(x) = hyperbolic cosine of an angle in rad',
    'degtorad(x) = conversion from degrees to radians',
    'exp(x) = the value of e raised to the power of x',
    'if(x1,x2,x3) = if x1=True(or 1) then x2 else x3',
    'ln(x) = natural logarithm of x',
    'log10(x) = logarithm base 10 of x',
    'logn(x1,x2) = logarithm base x1 of x2',
    'max(x1,x2) = the maximum of both arguments',
    'min(x1,x2) = the minimum of both arguments',
    'pi = 3.1415926535897932385',
    'radtodeg(x) = conversion from degrees to radians',
    'randg(x1,x2) = Draw from normal distrib. (mean=x1, sd =x2',
    'random = random number between 0 and 1',
    'round(x) = round to the nearest integer',
    'sin(x) = sine of an angle in rad',
    'sinh(x) = hyperbolic sine of an angle in rad',
    'sqr(x) = the square of a number (x*x)',
    'sqrt(x) = the square root of a number',
    'tanh(x) = the hyperbolic tangent of an angle (rad)',
    'trunc(x) = truncates a real number to an integer');
  FunctionStrings: array[0..Maxstrings - 1] of string = (
    '()', 'abs()', 'arccos()', 'arccosh()', 'arcsin()', 'arcsinh()',
    'cos()', 'cosh()', 'degtorad()', 'exp()', 'if(,,)', 'ln()', 'log10()',
    'logn(,)', 'max(,)', 'min(,)', 'pi', 'radtodeg()', 'randg(,)', 'random',
    'round()', 'sin()', 'sinh()', 'sqr()', 'sqrt()', 'tanh()', 'trunc()');

procedure TForm1.FormCreate(Sender: TObject);
var
  S: string;
  I, J: Integer;
begin
  //decimalseparator := ','; //for testing
  PointButton.Caption := decimalseparator;
  MyParser := TExpressionParser.Create;
  //alternatively
  //MyParser := TCStyleParser.Create;
  MyParser.DefineVariable('x', @X);
  MyParser.DefineVariable('y', @Y);
  MyParser.DefineVariable('z', @Z);
  X := StrToFloat(XEdit.Text);
  Y := StrToFloat(yEdit.Text);
  Z := StrToFloat(ZEdit.Text);
  FunctionsCombo.ItemIndex := 0;
  Iprevtext := -1;
  istartundo := -1;
  FunctionsCombo.Clear;
  for I := 0 to Maxstrings - 1 do
  begin
    S := Functionstrings[I];
    if MyParser.ArgSeparator <> ',' then
      repeat
        J := Pos(',', S);
        if J > 0 then S[J] := MyParser.ArgSeparator;
      until J = 0;
    FunctionsCombo.Items.Add(S);
  end;
end;



procedure TForm1.EvaluateClick(Sender: TObject);
var
  I: Integer;
  procedure SetEditText(Edit: TEdit; X: Double);
  var
    OnCh: TNotifyEvent;
  begin
    OnCh := Edit.OnChange;
    Edit.OnChange := nil;
    Edit.Text := FloatToStr(X);
    Edit.OnChange := OnCh;
  end;
begin
  MyParser.Optimize := OptimizeCheck.Checked;
  I := MyParser.AddExpression(ExpressionEdit.Text);
  if HexCheck.Checked then
    ResultEdit.Text := MyParser.AsHexadecimal[I]
  else
    ResultEdit.Text := MyParser.AsString[I];
  NEvalLabel.Caption := IntToStr(MyParser.ExpressionSize[I]);
  SetEditText(XEdit, X);
  SetEditText(yEdit, Y);
  SetEditText(ZEdit, Z);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: Integer;
begin
  I := MyParser.AddExpression(ExpressionEdit.Text);
  ResultEdit.Text := MyParser.AsString[I];
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  MyParser.Free;
end;

procedure TForm1.XEditChange(Sender: TObject);
begin
  if XEdit.Text <> '' then
  begin
    X := StrToFloat(XEdit.Text);
  end;
end;

procedure TForm1.YEditChange(Sender: TObject);
begin
  Y := StrToFloat(yEdit.Text);
end;

procedure TForm1.ZEditChange(Sender: TObject);
begin
  Z := StrToFloat(ZEdit.Text);
end;

procedure TForm1.Button24Click(Sender: TObject);
begin
  AddToEdit((Sender as TButton).Caption);
end;

procedure TForm1.UpdateUndo;
begin
  istartundo := -1;
  if (Iprevtext <= 0) or (PrevText[Iprevtext - 1] <> ExpressionEdit.Text) then
  begin
    Inc(Iprevtext);
    if Iprevtext >= Nundo then
      Iprevtext := 0;
    PrevText[Iprevtext] := ExpressionEdit.Text;
  end;
end;

procedure TForm1.AddToEdit(S: string);
var
  Len: Integer;
  IsFunction: Boolean;
begin
  if S = '' then S := ' ';
  with ExpressionEdit do
  begin
    IsFunction := Pos('(', S) > 0;
    Len := Sellength;
    if IsFunction and (Len > 0) then
    begin
      Sellength := 0;
      SelText := Copy(S, 1, Pos('(', S));
      SelStart := SelStart + Len;
      SelText := Copy(S, Pos('(', S) + 1, Len); ;
      SelStart := SelStart - 1;
    end
    else
    begin
      SelText := S;
      if IsFunction then SelStart := SelStart - 1;
    end;
  end;
end;

procedure TForm1.Button24KeyPress(Sender: TObject; var Key: Char);
begin
  ActiveControl := ExpressionEdit;
  with ExpressionEdit do
  begin
    SelStart := SelStart + Sellength;
    Sellength := 0;
  end;
end;

procedure TForm1.Button32Click(Sender: TObject);
begin
  AddToEdit(FunctionsCombo.Text);
end;

procedure TForm1.FunctionsComboChange(Sender: TObject);
var
  S: string;
  I: Integer;
begin
  if (FunctionsCombo.ItemIndex >= 0) and (FunctionsCombo.ItemIndex < Maxstrings) then
  begin
    S := Helpstrings[FunctionsCombo.ItemIndex];
    if MyParser.ArgSeparator <> ',' then
      repeat
        I := Pos(',', S);
        if I > 0 then S[I] := MyParser.ArgSeparator;
      until I = 0;
    Helplabel.Caption := S;
  end;
end;

procedure TForm1.SetUndoText;
begin
  with ExpressionEdit do
  begin
    OnChange := nil;
    Text := PrevText[Iprevtext];
    SelStart := SelStart + Length(Text);
    Sellength := 0;
    OnChange := ExpressionEditChange;
  end;
end;

procedure TForm1.Undo1Click(Sender: TObject);
begin
  if istartundo = -1 then istartundo := Iprevtext;
  Dec(Iprevtext);
  if Iprevtext < 0 then
    Iprevtext := Nundo - 1;
  SetUndoText;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  Undo1.Enabled := (Iprevtext <> -1);
  Redo1.Enabled := (istartundo <> -1) and (istartundo <> Iprevtext);
end;

procedure TForm1.ExpressionEditChange(Sender: TObject);
begin
  UpdateUndo;
end;

procedure TForm1.Redo1Click(Sender: TObject);
begin
  if Iprevtext <> istartundo then
  begin
    Inc(Iprevtext);
    if Iprevtext = Nundo then
      Iprevtext := 0;
  end;
  SetUndoText;
end;

procedure TForm1.OptimizeCheckClick(Sender: TObject);
begin
  MyParser.ClearExpressions;
end;

end.

